/*
@program   oslo-plaza-heis-v2.1
@forfatter Kim Olsen <kim@pizslacker.org>
@endret    20140125-23:53-GMT+1
*/

#include <stdio.h>
#include <unistd.h>

char *pversjon = "2.1"; // Peker til program-versjon char-tabell.
int destEtasje = 1; // Destinasjons-etasje.
int destEtasjeTmp; // Temporær destinasjons-etasje.
int denneEtasje = 1; // Nåværende etasje.
int maxEtasje = 37; // Siste etasje.
int minEtasje = 1; // Første etasje.
int teller = 1; // Tur-teller.
int turtall; // Resulterende antall heisturer.

int heisSporring() // spørre-funksjon for etasje-valg.
    {
        printf("\nVennligst oppgi et etasje-nummer (1-37) [99 for å avslutte]:\n"); // Spør bruker om etasje-valg.
        scanf("%d", &destEtasjeTmp); // Leser inn brukervalgt etasje.
        if (destEtasjeTmp == 99) // Brukerangitt verdi for å avslutte programmet.
        {
            turtall = teller -1; // Resulterende heistur-antall.
            teller = 0; // Nullstiller teller, som avslutter DO-WHILE-løkke i main().
        }
        if (destEtasjeTmp == denneEtasje) // Bruker befinner seg på valgt etasje, retur 1.
        {
            puts("\nDu befinner deg på valgt etasje!");
            return 1; // Returner 1.
        }
        if (destEtasjeTmp > maxEtasje) // Bruker har angitt et høyere tall enn 37.
        {
            puts("\nEtasjen finnes ikke! Går ikke lenger opp enn etasje 37.");
            return 1; // Returner 1.
        }
        if (destEtasjeTmp < minEtasje) // Bruker har angitt et mindre tall enn 1.
        {
            puts("\nEtasjen finnes ikke! Går ikke lenger ned enn etasje 1.");
            return 1; // Returner 1.
        }
        else
        {
            destEtasje = destEtasjeTmp;
        }
    }

void heisOpp() // Opp-funksjon.
    {
        teller++; // 
        printf("\nHeis kjører opp.\n"); // Skriver hva heisen foretar seg.
        for(denneEtasje == destEtasje; denneEtasje < destEtasje; denneEtasje++)
            printf(".\nEtasje %d\n", denneEtasje);
        if (denneEtasje == destEtasje) // Destinasjon nådd.
            {
            printf("\nDu befinner deg nå på etasje %d.\n", denneEtasje);
            }
    }

void heisNed() // Ned-funksjon.
    {
        teller++; //
        printf("\nHeis kjører ned.\n"); // Skriver hva heisen foretar seg.
        for(denneEtasje == destEtasje; denneEtasje > destEtasje; denneEtasje--)
            printf(".\nEtasje %d\n", denneEtasje);
        if (denneEtasje == destEtasje) // Destinasjon nådd.
            {
            printf("\nDu befinner deg nå på etasje %d.\n", denneEtasje);
            }
    }

int main() // Programmets main-funksjon.
{
    printf("Velkommen til Oslo Plaza heis v%s\n", pversjon); // Velkommen-beskjed + program-versjon.
    do // DO WHILE teller ISNOT 0.
    {
        heisSporring(); // Kjører spørre-funksjon.
        if (destEtasje > denneEtasje) // HVIS destEtasje STØRRE-ENN denneEtasje.
        {
            heisOpp(); // Kjører opp-funksjon.
        }
        if (destEtasje < denneEtasje) // HVIS destEtasje MINDRE-ENN denneEtasje.
        {
            heisNed(); // Kjører ned-funksjon.
        }
        if (destEtasje == 1) // HVIS destEtasje ER-LIK 1 (første etasje).
        {
            turtall = teller -1; // Resulterende heistur-antall.
            teller = 0; // Nullstill teller, som avslutter DO WHILE-løkke.
        }
    }
    while (teller != 0);
    // Skriver ut gjensyns-beskjed til bruker og avslutter.
    printf("\nDu benyttet heisen %d ganger.\n", turtall);
    puts("\nTakk for at du benyttet Oslo Plaza heis. På gjensyn!");
    return 0;
}
